/* Generated test code to dump a table of data for external validation
 * of the noise model parameters.
 */
#include <stdio.h>
#include <assert.h>
double compute_noise_model_entry_S(int plane, int sens);
double compute_noise_model_entry_O(int plane, int sens);
int main(void) {
    for (int plane = 0; plane < 4; plane++) {
        for (int sens = 50; sens <= 3200; sens += 100) {
            double o = compute_noise_model_entry_O(plane, sens);
            double s = compute_noise_model_entry_S(plane, sens);
            printf("%d,%d,%lf,%lf\n", plane, sens, o, s);
        }
    }
    return 0;
}

/* Generated functions to map a given sensitivity to the O and S noise
 * model parameters in the DNG noise model. The planes are in
 * R, Gr, Gb, B order.
 */
double compute_noise_model_entry_S(int plane, int sens) {
    static double noise_model_A[] = { 4.378003095729324e-06,4.390731350703014e-06,4.401564976885953e-06,4.3991797511437424e-06 };
    static double noise_model_B[] = { 7.649268650373968e-06,2.353806865582552e-05,2.3033050018777106e-05,1.0101353512946843e-05 };
    double A = noise_model_A[plane];
    double B = noise_model_B[plane];
    double s = A * sens + B;
    return s < 0.0 ? 0.0 : s;
}

double compute_noise_model_entry_O(int plane, int sens) {
    static double noise_model_C[] = { 4.244085454168517e-11,4.629295227657885e-11,4.5703583431510155e-11,4.3284335205553406e-11 };
    static double noise_model_D[] = { 3.7008229144360067e-07,-2.9036760970980814e-07,-2.693620772937755e-07,2.613077670714907e-07 };
    double digital_gain = (sens / 400.0) < 1.0 ? 1.0 : (sens / 400.0);
    double C = noise_model_C[plane];
    double D = noise_model_D[plane];
    double o = C * sens * sens + D * digital_gain * digital_gain;
    return o < 0.0 ? 0.0 : o;
}
